<?php
/***********************************************************
Flip  plugin for CMSimple 
works on the file structure builded by the great Gallery by Michael Svarrer
admin.php of this plugin is writed by Amir

It's not necessary to use Svarrers Gallery to run this plugin but it make's work much easier.
Otherwise you have to manualy create the same file structure as Svarrers gallery does. 
Use  

Tested with modyfied version of gallery by Holger Irmler: Svarrers Gallery with Lightbox:
Lightbox version 2.04, 
php 4.3 and 5.2 
in IE8, Firefox and Chrome.

Unzip downloaded file and move carousel folder to plugin folder of your CMSimple website.
To activate insert #CMSimple $output.= carousel('/path/to/your/gallery/folder');# somewher on your page.

Disclaimer : No warranties at all, use on your own risk !
Requirements : The Plugin-Loader must be installed and working ! , client must have flash player 9.0 or higher
***********************************************************/
function flipgl($path) {
	global $plugin_cf, $plugin_tx, $plugin,$pth, $_SERVER;
	$plugin = basename(dirname(__FILE__), "/");
	
	$path=rtrim($path,"/");
	$xmlfile = $pth['folder']['plugins'].$plugin."/data/".time().".xml";
	flipgl_cleandir($pth['folder']['plugins'].$plugin."/data/","*.xml");
	$flashfile = $pth['folder']['plugins'] . $plugin."/data/flip.swf";	
	$xmlc='
	<?xml version="1.0" encoding="utf-8"?>
	<!-- fhShow Flip 1.0 configuration file. Please visit http://www.flshow.net/ -->
	<slide_show>
	<options>
		<debug>'.$plugin_cf['flipgl']['debug'].'</debug>
		<background>'.$plugin_cf['flipgl']['background'].'</background>
		<friction>'.$plugin_cf['flipgl']['friction'].'</friction>
    <fullscreen>'.$plugin_cf['flipgl']['fullscreen'].'</fullscreen>
    <fieldOfView>'.$plugin_cf['flipgl']['fieldOfView'].'</fieldOfView>
    <margins>
      <top>'.$plugin_cf['flipgl']['margins_top'].'</top>
      <left>'.$plugin_cf['flipgl']['margins_left'].'</left>
      <bottom>'.$plugin_cf['flipgl']['margins_bottom'].'</bottom>
      <right>'.$plugin_cf['flipgl']['margins_right'].'</right>
    </margins>
		<interaction>
			<flip>'.$plugin_cf['flipgl']['interaction_flip'].'</flip>		
			<vertical>'.$plugin_cf['flipgl']['interaction_vertical'].'</vertical>			
			<speed>'.$plugin_cf['flipgl']['interaction_speed'].'</speed>								
			<default_speed>'.$plugin_cf['flipgl']['interaction_default_speed'].'</default_speed>
      <reset_delay>'.$plugin_cf['flipgl']['interaction_reset_delay'].'</reset_delay>                 				 
		</interaction>	
		<reflection>
			<amout>'.$plugin_cf['flipgl']['reflection_amout'].'</amout>						
			<blur>'.$plugin_cf['flipgl']['reflection_blur'].'</blur>							
			<distance>'.$plugin_cf['flipgl']['reflection_distance'].'</distance>	
			<alpha>'.$plugin_cf['flipgl']['reflection_alpha'].'</alpha>						
		</reflection>
		<titles>
    	<default_style>font-size: 10px; font-family: Verdana, _serif; color: #333333;</default_style>
    </titles>
	</options>'."\n";

	$fpw = fopen($xmlfile, 'w+') or die("Can't open file");
	fwrite($fpw, $xmlc);
	$o.='<div id="flipgl_anchorsdiv">';
	$handle = @opendir($path) or die("Unable to open $path");
	$id=0;
	while (false !== ($file = readdir($handle))) {
		$exts = split("[/\\.]", $file) ;
		$exts = $exts[count($exts)-1]; 
		if (strtolower($exts)=='jpg') {
		  $title=flipgl_get_gallery_title($path,$file);
			$o.='<a rel="lightbox';
			if ($plugin_cf['flipgl']['lightbox_group']!="")
        $o.='['.$plugin_cf['flipgl']['lightbox_group'].']';
      if(eregi("true",$plugin_cf['flipgl']['show_titles_lightbox']))
	      $o.='" title="'.$title.'"';
			$o.='" href="'.$path.'/'.$file;
			$o.='" id="anchor'.++$id.'_id"><img src="';
			$o.=$path.'/'.$file;
			$o.='" alt="'.$file.'" /></a>';
			fwrite($fpw,'<photo href="javascript:aclick(\'anchor'.$id.'_id\')" target="_self">'.$path.'/thumb/tn_'.$file.'</photo>');
	  }
	}
	$o.='</div>';	
	closedir($handle);
	fwrite($fpw,'</slide_show>');
	flush();
	fclose($fpw);
	$t.='	
	<div id="flipgl_cardiv">
	<!-- IE (et. al) Object -->
	<object class="flipgl_movie" id="Flip__ie"	
		classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"
		codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0">
		<param name="movie" value="'.$flashfile.'" />
		<param name="flashvars" value="xmlfile='.$xmlfile.'" />
		<param name="quality" value="High" />
		<param name="bgcolor" value="#FFFFFF" />
			<!--[if !IE]>-->

			<!-- Firefox (et. al) Object -->
			<object class="flipgl_movie" id="Flip__ff"
				type="application/x-shockwave-flash"
				data="'.$flashfile.'">
				<param name="movie" value="'.$flashfile.'" />
				<param name="flashvars" value="xmlfile='.$xmlfile.'" />
				<param value="opaque" name="wmode">
				<param name="quality" value="high" />
				<param name="bgcolor" value="#ffffff" />
				<param name="pluginurl" value="http://www.macromedia.com/go/getflashplayer"/>
				
					<!-- No plugin -->
					<p>This page require <a href="http://www.adobe.com/">Adobe Flash 9.0</a> (or higher) plug in.</p>

			</object>
			
			<!--<![endif]-->
	</object>
	';
	$t.=$o;
	//DO NOT REMOVE. To hide change class carousel_credits to display:none; font-size:0px; in css/styleshit.css
	$t.='<p class="flipgl_credits">CMSimple plugin by Jerry Jakobsfeld</p>';
	$t.='</div>';
	//DO NOT REMOVE. To hide change class carousel_credits to display:none; font-size:0px; in css/styleshit.css
	return $t;
}

function flipgl_get_gallery_title($path,$file){
	// no support for gallerys multilanguage comments.
	$t='no title';
	$filename=preg_replace("/.jpg/i",".txt",$path.'/'.$file);
	if(file_exists($filename)){
		$fp=fopen($filename,"r");
		$line = fgets( $fp, 2024 );
		$title = explode(";", $line);
		$t=$title[0];
	} 	
	fclose($fp);
	return $t;
}


function flipgl_cleandir($path,$match){
   $dirs = glob($path."*");
   $files = glob($path.$match);
   foreach($files as $file){
      if(is_file($file)){
         unlink($file);
       }
   }
   foreach($dirs as $dir){
      if(is_dir($dir)){
         $dir = basename($dir) . "/";
         cleandir($path.$dir,$match);
      }
   }
} 

?>